OGRE: Ogre::SubItem Class Reference

| OGRE 2.2.4 Object-Oriented Graphics Rendering Engine

Public Types | Public Member Functions | Public Attributes | Friends | List of all members
Ogre::SubItem Class Reference
Core | Component » Scene

Utility class which defines the sub-parts of an Item. More...

`#include <OgreSubItem.h>`

Inheritance diagram for Ogre::SubItem:
[legend]

## Public Types
typedef map< size_t, Vector4 >::type | CustomParameterMap
typedef FastArray< unsigned short > | IndexMap

## Public Member Functions
virtual | ~SubItem ()
| Destructor. More...
virtual void | _setHlmsHashes (uint32 hash, uint32 casterHash)
| Manually sets the hlms hashes. Don't call this directly. More...
virtual void | _setNullDatablock (void)
| Sets the datablock to a null pointer. More...
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows. More...
void | addPoseWeight (const Ogre::String &poseName, float w)
void | addPoseWeight (size_t index, float w)
void | addPoseWeight (size_t index, float w)
const IndexMap * | getBlendIndexToBoneIndexMap (void) const
virtual bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow. More...
uint8 | getCurrentMaterialLod (void) const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index. More...
const CustomParameterMap & | getCustomParameters (void) const
HlmsDatablock * | getDatablock (void) const
uint32 | getHlmsCasterHash (void) const
uint32 | getHlmsHash (void) const
const LightList & | getLights (void) const
| Gets a list of lights, ordered relative to how close they are to this renderable. More...
MaterialPtr | getMaterial (void) const
| Retrieves the material this renderable object uses. More...
unsigned short | getNumPoses (void) const
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires. More...
Item * | getParent (void) const
| Accessor to get parent Item. More...
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. More...
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (const Ogre::String &poseName) const
float | getPoseWeight (size_t index) const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
virtual void | getRenderOperation (v1::RenderOperation &op, bool casterPass)
| Gets the render operation required to send this object to the frame buffer. More...
uint8 | getRenderQueueSubGroup (void) const
SubMesh * | getSubMesh (void) const
| Accessor method to read mesh data. More...
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection. More...
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view. More...
virtual bool | getUseIdentityViewProjMatrixIsDynamic (void) const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization) More...
virtual bool | getUseIdentityWorldMatrix (void) const
| Returns whether the world matrix is an identity matrix. More...
virtual OGRE_DEPRECATED const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class. More...
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class. More...
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
virtual void | getWorldTransforms (Matrix4 *xform) const
| Gets the world transform matrix / matrices for this renderable object. More...
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index. More...
bool | hasSkeletonAnimation (void) const
void | operator delete (void *ptr)
void | operator delete (void *ptr, const char *, int, const char *)
void | operator delete (void *ptr, void *)
void | operator delete[] (void *ptr)
void | operator delete[] (void *ptr, const char *, int, const char *)
void * | operator new (size_t sz)
void * | operator new (size_t sz, const char *file, int line, const char *func)
| operator new, with debug line info More...
void * | operator new (size_t sz, void *ptr)
| placement operator new More...
void * | operator new[] (size_t sz)
void * | operator new[] (size_t sz, const char *file, int line, const char *func)
| array operator new, with debug line info More...
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered. More...
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered. More...
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index. More...
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters. More...
virtual void | setDatablock (HlmsDatablock *datablock)
| Assigns a datablock (i.e. HLMS Material) to this renderable. More...
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e. More...
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials. More...
virtual void | setMaterial (const MaterialPtr &material)
| Sets the given material. Overrides HLMS materials. More...
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS @See setHlms. More...
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. More...
void | setPoseWeight (const Ogre::String &poseName, float w)
void | setPoseWeight (size_t index, float w)
void | setPoseWeight (size_t index, float w)
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group. More...
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection. More...
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view. More...
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)

## Public Attributes
uint8 | mCustomParameter
| Only valid when using low level materials. More...
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock. More...

## Friends
class | Item
class | SceneManager

## Detailed Description

Utility class which defines the sub-parts of an Item.

Remarks
  Just as meshes are split into submeshes, an Item is made up of potentially multiple SubMeshes. These are mainly here to provide the link between the Material which the SubItem uses (which may be the default Material for the SubMesh or may have been changed for this object) and the SubMesh data.

  The SubItem also allows the application some flexibility in the material properties for this section of a particular instance of this Mesh, e.g. tinting the windows on a car model.

  SubItem instances are never created manually. They are created at the same time as their parent Item by the SceneManager method createItem.

## Member Typedef Documentation

## ◆ CustomParameterMap

typedef map<size_t, Vector4>::type Ogre::Renderable::CustomParameterMap
| inherited

## ◆ IndexMap

typedef FastArray<unsigned short> Ogre::RenderableAnimated::IndexMap
| inherited

## Constructor & Destructor Documentation

## ◆ ~SubItem()

virtual Ogre::SubItem::~SubItem | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ _setHlmsHashes()

virtual void Ogre::SubItem::_setHlmsHashes | ( | uint32 | hash,
|  | uint32 | casterHash
| ) |  |
| virtual

Manually sets the hlms hashes. Don't call this directly.

Reimplemented from Ogre::Renderable.

## ◆ _setNullDatablock()

virtual void Ogre::Renderable::_setNullDatablock | ( | void |  | ) |
| virtualinherited

Sets the datablock to a null pointer.

Use case: If you will be destroying an HlmsDatablock and all Renderables associated by it; it makes no sense to change the Renderable's datablock to a default one, only to be destroyed immediately after (you pay an unnecessary performance price).

Remarks
  Do not attempt to render a Renderable whose datablock has been set to null. It will crash. You can call setDatablock afterwards though. Use at your own risk, hence the _underscore. See http://ogre3d.org/forums/viewtopic.php?f=25&t=91791&p=534476#p534476

Reimplemented in Ogre::v1::SubEntity, and Ogre::v1::BillboardSet.

## ◆ _updateCustomGpuParameter()

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters_AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params
| ) |  | const
| virtualinherited

Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.

Remarks
  This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter.

  You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case.

Parameters

  constantEntry | The auto constant entry referring to the parameter being updated
  params | The parameters object which this method should call to set the updated parameters.

Reimplemented in Ogre::v1::SubEntity.

## ◆ addPoseWeight() [1/3]

void Ogre::SubItem::addPoseWeight | ( | const Ogre::String & | poseName,
|  | float | w
| ) |  |

## ◆ addPoseWeight() [2/3]

void Ogre::Renderable::addPoseWeight | ( | size_t | index,
|  | float | w
| ) |  |
| inherited

## ◆ addPoseWeight() [3/3]

void Ogre::Renderable::addPoseWeight

## ◆ getBlendIndexToBoneIndexMap()

const IndexMap* Ogre::RenderableAnimated::getBlendIndexToBoneIndexMap | ( | void |  | ) | const
| inlineinherited

## ◆ getCastsShadows()

virtual bool Ogre::SubItem::getCastsShadows | ( | void |  | ) | const
| virtual

Method which reports whether this renderable would normally cast a shadow.

Remarks
  Subclasses should override this if they could have been used to generate a shadow.

Reimplemented from Ogre::Renderable.

## ◆ getCurrentMaterialLod()

uint8 Ogre::Renderable::getCurrentMaterialLod | ( | void |  | ) | const
| inlineinherited

## ◆ getCustomParameter()

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const
| inlineinherited

Gets the custom value associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to retrieve.

See also
  setCustomParameter for full details.

References Ogre::Exception::ERR_ITEM_NOT_FOUND, and OGRE_EXCEPT.

## ◆ getCustomParameters()

const CustomParameterMap& Ogre::Renderable::getCustomParameters | ( | void |  | ) | const
| inlineinherited

## ◆ getDatablock()

HlmsDatablock* Ogre::Renderable::getDatablock | ( | void |  | ) | const
| inlineinherited

## ◆ getHlmsCasterHash()

uint32 Ogre::Renderable::getHlmsCasterHash | ( | void |  | ) | const
| inlineinherited

## ◆ getHlmsHash()

uint32 Ogre::Renderable::getHlmsHash | ( | void |  | ) | const
| inlineinherited

## ◆ getLights()

const LightList& Ogre::SubItem::getLights | ( | void |  | ) | const
| virtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Remarks
  Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## ◆ getMaterial()

MaterialPtr Ogre::Renderable::getMaterial | ( | void |  | ) | const
| inherited

Retrieves the material this renderable object uses.

It may be null if it's using the HLMS. @See getDatablock

## ◆ getNumPoses()

unsigned short Ogre::Renderable::getNumPoses | ( | void |  | ) | const
| inherited

## ◆ getNumWorldTransforms()

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const
| inlinevirtualinherited

Returns the number of world transform matrices this renderable requires.

Remarks
  When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity.

Reimplemented in Ogre::v1::SubEntity, and Ogre::v1::BorderRenderable.

## ◆ getParent()

Item* Ogre::SubItem::getParent | ( | void |  | ) | const
| inline

Accessor to get parent Item.

## ◆ getPolygonModeOverrideable()

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const
| inlinevirtualinherited

Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Reimplemented in Ogre::v1::BorderRenderable.

Referenced by Ogre::v1::BorderRenderable::getPolygonModeOverrideable().

## ◆ getPoseHalfPrecision()

bool Ogre::Renderable::getPoseHalfPrecision | ( |  | ) | const
| inherited

## ◆ getPoseNormals()

bool Ogre::Renderable::getPoseNormals | ( |  | ) | const
| inherited

## ◆ getPoseTexBuffer()

TexBufferPacked* Ogre::Renderable::getPoseTexBuffer | ( |  | ) | const
| inherited

## ◆ getPoseWeight() [1/3]

float Ogre::SubItem::getPoseWeight | ( | const Ogre::String & | poseName | ) | const

## ◆ getPoseWeight() [2/3]

float Ogre::Renderable::getPoseWeight | ( | size_t | index | ) | const
| inherited

## ◆ getPoseWeight() [3/3]

float Ogre::Renderable::getPoseWeight

## ◆ getPoseWeights()

float* Ogre::Renderable::getPoseWeights | ( |  | ) | const
| inherited

## ◆ getRenderOperation()

virtual void Ogre::SubItem::getRenderOperation | ( | v1::RenderOperation & | op,
|  | bool | casterPass
| ) |  |
| virtual

Gets the render operation required to send this object to the frame buffer.

Implements Ogre::Renderable.

## ◆ getRenderQueueSubGroup()

uint8 Ogre::Renderable::getRenderQueueSubGroup | ( | void |  | ) | const
| inlineinherited

## ◆ getSubMesh()

SubMesh* Ogre::SubItem::getSubMesh | ( | void |  | ) | const

Accessor method to read mesh data.

## ◆ getUseIdentityProjection()

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const
| inlineinherited

Returns whether or not to use an 'identity' projection.

Remarks
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this.

See also
  Renderable::setUseIdentityProjection

## ◆ getUseIdentityView()

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const
| inlineinherited

Returns whether or not to use an 'identity' view.

Remarks
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this.

See also
  Renderable::setUseIdentityView

## ◆ getUseIdentityViewProjMatrixIsDynamic()

virtual bool Ogre::Renderable::getUseIdentityViewProjMatrixIsDynamic | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization)

Remarks
  Hlms implementations may ignore this setting (e.g. assume always true or always false) or even not support identity matrix overrides at all. For example currently Unlit supports them all, but will assume this returns always true if getUseIdentityWorldMatrix returns false.

## ◆ getUseIdentityWorldMatrix()

virtual bool Ogre::Renderable::getUseIdentityWorldMatrix | ( | void |  | ) | const
| inlinevirtualinherited

Returns whether the world matrix is an identity matrix.

Remarks
  It is up to the Hlms implementation whether to honour this request. Take in mind changes of this value at runtime may not be seen until the datablock is flushed. It is implemented as a virtual call because this functionality isn't required very often (hence we save per-Renderable space for those that don't use it) and this function will be called at creation time to use a different shader; not during rendering time per Renderable.

Reimplemented in Ogre::v1::BillboardSet.

## ◆ getUserAny()

virtual OGRE_DEPRECATED const Any& Ogre::Renderable::getUserAny | ( | void |  | ) | const
| inlinevirtualinherited

Deprecated:
  use UserObjectBindings::getUserAny via getUserObjectBindings() instead. Retrieves the custom user value associated with this object.

## ◆ getUserObjectBindings() [1/2]

UserObjectBindings& Ogre::Renderable::getUserObjectBindings | ( |  | ) |
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getUserObjectBindings() [2/2]

const UserObjectBindings& Ogre::Renderable::getUserObjectBindings | ( |  | ) | const
| inlineinherited

Return an instance of user objects binding associated with this class.

You can use it to associate one or more custom objects with this class instance.

See also
  UserObjectBindings::setUserAny.

## ◆ getVaos()

const VertexArrayObjectArray& Ogre::Renderable::getVaos | ( | VertexPass | vertexPass | ) | const
| inlineinherited

## ◆ getWorldTransforms()

virtual void Ogre::SubItem::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| virtual

Gets the world transform matrix / matrices for this renderable object.

Remarks
  If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

  This method will populate transform with 1 matrix if it does not use vertex blending. If it does use vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

See also
  Matrix4::isAffine.

Implements Ogre::Renderable.

## ◆ hasCustomParameter()

bool Ogre::Renderable::hasCustomParameter | ( | size_t | index | ) | const
| inlineinherited

Checks whether a custom value is associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to check for existence.

See also
  setCustomParameter for full details.

## ◆ hasSkeletonAnimation()

bool Ogre::Renderable::hasSkeletonAnimation | ( | void |  | ) | const
| inlineinherited

## ◆ operator delete() [1/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete() [2/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator delete() [3/3]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete | ( | void * | ptr,
|  | void * |
| ) |  |
| inlineinherited

## ◆ operator delete[]() [1/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr | ) |
| inlineinherited

## ◆ operator delete[]() [2/2]

template<class Alloc >

void Ogre::AllocatedObject< Alloc >::operator delete[] | ( | void * | ptr,
|  | const char * | ,
|  | int | ,
|  | const char * |
| ) |  |
| inlineinherited

## ◆ operator new() [1/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new() [2/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

operator new, with debug line info

## ◆ operator new() [3/3]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new | ( | size_t | sz,
|  | void * | ptr
| ) |  |
| inlineinherited

placement operator new

## ◆ operator new[]() [1/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz | ) |
| inlineinherited

## ◆ operator new[]() [2/2]

template<class Alloc >

void* Ogre::AllocatedObject< Alloc >::operator new[] | ( | size_t | sz,
|  | const char * | file,
|  | int | line,
|  | const char * | func
| ) |  |
| inlineinherited

array operator new, with debug line info

## ◆ postRender()

virtual void Ogre::Renderable::postRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys
| ) |  |
| inlinevirtualinherited

Called immediately after the Renderable has been rendered.

## ◆ preRender()

virtual bool Ogre::Renderable::preRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys
| ) |  |
| inlinevirtualinherited

Called just prior to the Renderable being rendered.

Remarks
  OGRE is a queued renderer, so the actual render commands are executed at a later time than the point at which an object is discovered to be visible. This allows ordering & grouping of renders without the discovery process having to be aware of it. It also means OGRE uses declarative render information rather than immediate mode rendering - this is very useful in that certain effects and processes can automatically be applied to a wide range of scenes, but the downside is that special cases are more difficult to handle, because there is not the declared state to cope with it.

  This method allows a Renderable to do something special at the actual point of rendering if it wishes to. When this method is called, all the material render state as declared by this Renderable has already been set, all that is left to do is to bind the buffers and perform the render. The Renderable may modify render state itself if it wants to (and restore it in the postRender call) before the automated render happens, or by returning 'false' from this method can actually suppress the automatic render and perform one of its own.

Returns
  true if the automatic render should proceed, false to skip it on the assumption that the Renderable has done it manually.

Reimplemented in Ogre::v1::BillboardChain.

## ◆ removeCustomParameter()

void Ogre::Renderable::removeCustomParameter | ( | size_t | index | ) |
| inlineinherited

Removes a custom value which is associated with this Renderable at the given index.

Parameters

  index | Index of the parameter to remove.

See also
  setCustomParameter for full details.

## ◆ setCustomParameter()

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value
| ) |  |
| inlineinherited

Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.

Remarks
  Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter.

Parameters

  index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  value | The value to associate.

## ◆ setDatablock() [1/2]

virtual void Ogre::Renderable::setDatablock | ( | HlmsDatablock * | datablock | ) |
| virtualinherited

Assigns a datablock (i.e. HLMS Material) to this renderable.

Reimplemented in Ogre::v1::SubEntity, and Ogre::v1::BillboardSet.

## ◆ setDatablock() [2/2]

void Ogre::Renderable::setDatablock | ( | IdString | datablockName | ) |
| inherited

Assigns a datablock (i.e.

HLMS material) based on its unique name.

Remarks
  An null IdString() is valid, it will use the default material

## ◆ setDatablockOrMaterialName()

void Ogre::Renderable::setDatablockOrMaterialName | ( | String | materialName,
|  | String | groupName
| ) |  |
| inherited

First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.

## ◆ setMaterial()

virtual void Ogre::Renderable::setMaterial | ( | const MaterialPtr & | material | ) |
| virtualinherited

Sets the given material. Overrides HLMS materials.

Reimplemented in Ogre::v1::SubEntity, Ogre::v1::BillboardSet, and Ogre::v1::SimpleRenderable.

## ◆ setMaterialName()

void Ogre::Renderable::setMaterialName | ( | const String & | name,
|  | const String & | groupName
| ) |  |
| inherited

Sets the name of the Material to be used. Prefer using HLMS @See setHlms.

## ◆ setPolygonModeOverrideable()

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) |
| inlinevirtualinherited

Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.

Parameters

  override | true means that a lower camera detail will override this renderables detail level, false means it won't.

## ◆ setPoseWeight() [1/3]

void Ogre::SubItem::setPoseWeight | ( | const Ogre::String & | poseName,
|  | float | w
| ) |  |

## ◆ setPoseWeight() [2/3]

void Ogre::Renderable::setPoseWeight | ( | size_t | index,
|  | float | w
| ) |  |
| inherited

## ◆ setPoseWeight() [3/3]

void Ogre::Renderable::setPoseWeight

## ◆ setRenderQueueSubGroup()

void Ogre::Renderable::setRenderQueueSubGroup | ( | uint8 | subGroup | ) |
| inlineinherited

Sets the render queue sub group.

Remarks
  Within the same RenderQueue ID, you may want to have the renderables to have a specific order (i.e. have a mesh, but the hair submesh with alpha blending needs to be rendered last).

  RenderQueue Subgroups are useful for manually sorting objects, just like RenderQueue IDs. However, RenderQueue IDs can also be useful for skipping large number of objects through clever compositing and thus a performance optimization. Subgroups cannot be used for such optimizations.

Parameters

  subGroup | The sub group. This value can't exceed OGRE_MAKE_MASK( SubRqIdBits ) @See RenderQueue

## ◆ setUseIdentityProjection()

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) |
| inlineinherited

Sets whether or not to use an 'identity' projection.

Remarks
  Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also
  Renderable::getUseIdentityProjection

## ◆ setUseIdentityView()

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) |
| inlineinherited

Sets whether or not to use an 'identity' view.

Remarks
  Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false.

See also
  Renderable::getUseIdentityView

## ◆ setUserAny()

virtual OGRE_DEPRECATED void Ogre::Renderable::setUserAny | ( | const Any & | anything | ) |
| inlinevirtualinherited

Deprecated:
  use UserObjectBindings::setUserAny via getUserObjectBindings() instead. Sets any kind of user value on this object.

Remarks
  This method allows you to associate any user value you like with this Renderable. This can be a pointer back to one of your own classes for instance.

## Friends And Related Function Documentation

## ◆ Item

friend class Item
| friend

## ◆ SceneManager

friend class SceneManager
| friend

## Member Data Documentation

## ◆ mCustomParameter

uint8 Ogre::Renderable::mCustomParameter
| inherited

Only valid when using low level materials.

## ◆ mHlmsGlobalIndex

uint32 Ogre::Renderable::mHlmsGlobalIndex
| inherited

Index in the vector holding this Rendrable reference in the HLMS datablock.

Used for O(1) removals.

Remarks
  Despite being public, Do NOT modify it manually.

The documentation for this class was generated from the following file:

- OgreSubItem.h